/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
package net.micode.notes.ui;
 
import android.content.Context;
import android.database.Cursor;
import android.text.TextUtils;
 
import net.micode.notes.data.Contact;
import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.tool.DataUtils;
 
// 该类用于从数据库游标中提取笔记项数据，并处理与笔记位置相关的逻辑
public class NoteItemData {
    static final String [] PROJECTION = new String [] {
        NoteColumns.ID,
        NoteColumns.ALERTED_DATE,
        NoteColumns.BG_COLOR_ID,
        NoteColumns.CREATED_DATE,
        NoteColumns.HAS_ATTACHMENT,
        NoteColumns.MODIFIED_DATE,
        NoteColumns.NOTES_COUNT,
        NoteColumns.PARENT_ID,
        NoteColumns.SNIPPET,
        NoteColumns.TYPE,
        NoteColumns.WIDGET_ID,
        NoteColumns.WIDGET_TYPE,
    };
 
    // 定义了游标中各个列的索引位置
    private static final int ID_COLUMN                    = 0;
    private static final int ALERTED_DATE_COLUMN          = 1;
    private static final int BG_COLOR_ID_COLUMN           = 2;
    private static final int CREATED_DATE_COLUMN          = 3;
    private static final int HAS_ATTACHMENT_COLUMN        = 4;
    private static final int MODIFIED_DATE_COLUMN         = 5;
    private static final int NOTES_COUNT_COLUMN           = 6;
    private static final int PARENT_ID_COLUMN             = 7;
    private static final int SNIPPET_COLUMN               = 8;
    private static final int TYPE_COLUMN                  = 9;
    private static final int WIDGET_ID_COLUMN             = 10;
    private static final int WIDGET_TYPE_COLUMN           = 11;
 
    // 笔记项的各种属性
    private long mId;
    private long mAlertDate;
    private int mBgColorId;
    private long mCreatedDate;
    private boolean mHasAttachment;
    private long mModifiedDate;
    private int mNotesCount;
    private long mParentId;
    private String mSnippet;
    private int mType;
    private int mWidgetId;
    private int mWidgetType;
    private String mName;
    private String mPhoneNumber;
 
    // 笔记项在列表中的位置信息
    private boolean mIsLastItem;
    private boolean mIsFirstItem;
    private boolean mIsOnlyOneItem;
    private boolean mIsOneNoteFollowingFolder;
    private boolean mIsMultiNotesFollowingFolder;
 
    // 构造函数，从游标中提取笔记项数据
    public NoteItemData(Context context, Cursor cursor) {
        mId = cursor.getLong(ID_COLUMN);
        mAlertDate = cursor.getLong(ALERTED_DATE_COLUMN);
        mBgColorId = cursor.getInt(BG_COLOR_ID_COLUMN);
        mCreatedDate = cursor.getLong(CREATED_DATE_COLUMN);
        mHasAttachment = (cursor.getInt(HAS_ATTACHMENT_COLUMN) > 0) ? true : false;
        mModifiedDate = cursor.getLong(MODIFIED_DATE_COLUMN);
        mNotesCount = cursor.getInt(NOTES_COUNT_COLUMN);
        mParentId = cursor.getLong(PARENT_ID_COLUMN);
        mSnippet = cursor.getString(SNIPPET_COLUMN);
        mSnippet = mSnippet.replace(NoteEditActivity.TAG_CHECKED, "").replace(
                NoteEditActivity.TAG_UNCHECKED, "");
        mType = cursor.getInt(TYPE_COLUMN);
        mWidgetId = cursor.getInt(WIDGET_ID_COLUMN);
        mWidgetType = cursor.getInt(WIDGET_TYPE_COLUMN);
 
        mPhoneNumber = "";
        if (mParentId == Notes.ID_CALL_RECORD_FOLDER) {
            mPhoneNumber = DataUtils.getCallNumberByNoteId(context.getContentResolver(), mId);
            if (!TextUtils.isEmpty(mPhoneNumber)) {
                mName = Contact.getContact(context, mPhoneNumber);
                if (mName == null) {
                    mName = mPhoneNumber;
                }
            }
        }
 
        if (mName == null) {
            mName = "";
        }
        checkPostion(cursor);
    }
 
    // 检查笔记项在列表中的位置信息
    private void checkPostion(Cursor cursor) {
        mIsLastItem = cursor.isLast() ? true : false;
        mIsFirstItem = cursor.isFirst() ? true : false;
        mIsOnlyOneItem = (cursor.getCount() == 1);
        mIsMultiNotesFollowingFolder = false;
        mIsOneNoteFollowingFolder = false;
 
        if (mType == Notes.TYPE_NOTE && !mIsFirstItem) {
            int position = cursor.getPosition();
            if (cursor.moveToPrevious()) {
                if (cursor.getInt(TYPE_COLUMN) == Notes.TYPE_FOLDER
                        || cursor.getInt(TYPE_COLUMN) == Notes.TYPE_SYSTEM) {
                    if (cursor.getCount() > (position + 1)) {
                        mIsMultiNotesFollowingFolder = true;
                    } else {
                        mIsOneNoteFollowingFolder = true;
                    }
                }
                if (!cursor.moveToNext()) {
                    throw new IllegalStateException("cursor move to previous but can't move back");
                }
            }
        }
    }
 
    // 判断该笔记项是否是单个笔记跟在一个文件夹后
    public boolean isOneFollowingFolder() {
        return mIsOneNoteFollowingFolder;
    }
 
    // 判断该笔记项是否是多个笔记跟在一个文件夹后
    public boolean isMultiFollowingFolder() {
        return mIsMultiNotesFollowingFolder;
    }
 
    // 判断该笔记项是否是列表中的最后一个项
    public boolean isLast() {
        return mIsLastItem;
    }
 
    // 获取与该笔记项关联的呼叫记录的联系人名称
    public String getCallName() {
        return mName;
    }
 
    // 判断该笔记项是否是列表中的第一个项
    public boolean isFirst() {
        return mIsFirstItem;
    }
 
    // 判断该笔记项是否是列表中唯一的项
    public boolean isSingle() {
        return mIsOnlyOneItem;
    }
 
    // 获取笔记项的ID
    public long getId() {
        return mId;
    }
 
    // 获取笔记项的提醒日期
    public long getAlertDate() {
        return mAlertDate;
    }
 
    // 获取笔记项的创建日期
    public long getCreatedDate() {
        return mCreatedDate;
    }
 
    // 判断该笔记项是否有附件
    public boolean hasAttachment() {
        return mHasAttachment;
    }
 
    // 获取笔记项的修改日期
    public long getModifiedDate() {
        return mModifiedDate;
    }
 
    // 获取笔记项的背景颜色ID
    public int getBgColorId() {
        return mBgColorId;
    }
 
    // 获取笔记项的父ID
    public long getParentId() {
        return mParentId;
    }
 
    // 获取笔记项包含的笔记数量
    public int getNotesCount() {
        return mNotesCount;
    }
 
    // 获取笔记项所在的文件夹ID
    public long getFolderId () {
        return mParentId;
    }
 
    // 获取笔记项的类型
    public int getType() {
        return mType;
    }
 
    // 获取笔记项的小部件类型
    public int getWidgetType() {
        return mWidgetType;
    }
 
    // 获取笔记项的小部件ID
    public int getWidgetId() {
        return mWidgetId;
    }
 
    // 获取笔记项的摘要
    public String getSnippet() {
        return mSnippet;
    }
 
    // 判断该笔记项是否有提醒
    public boolean hasAlert() {
        return (mAlertDate > 0);
    }
 
    // 判断该笔记项是否是呼叫记录类型
    public boolean isCallRecord() {
        return (mParentId == Notes.ID_CALL_RECORD_FOLDER && !TextUtils.isEmpty(mPhoneNumber));
    }
 
    // 静态方法，从游标中获取笔记项的类型
    public static int getNoteType(Cursor cursor) {
        return cursor.getInt(TYPE_COLUMN);
    }
}